"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
var plugin_syntax_jsx_1 = require("@babel/plugin-syntax-jsx");
var helper_plugin_utils_1 = require("@babel/helper-plugin-utils");
var core_1 = require("@babel/core");
var helper_module_imports_1 = require("@babel/helper-module-imports");
var helper_annotate_as_pure_1 = require("@babel/helper-annotate-as-pure");
var DEFAULT = {
    importSource: "react",
    runtime: "automatic",
    pragma: "React.createElement",
    pragmaFrag: "React.Fragment"
};
var JSX_SOURCE_ANNOTATION_REGEX = /^\s*\*?\s*@jsxImportSource\s+([^\s]+)\s*$/m;
var JSX_RUNTIME_ANNOTATION_REGEX = /^\s*\*?\s*@jsxRuntime\s+([^\s]+)\s*$/m;
var JSX_ANNOTATION_REGEX = /^\s*\*?\s*@jsx\s+([^\s]+)\s*$/m;
var JSX_FRAG_ANNOTATION_REGEX = /^\s*\*?\s*@jsxFrag\s+([^\s]+)\s*$/m;
var get = function (pass, name) {
    return pass.get("@babel/plugin-react-jsx/".concat(name));
};
var set = function (pass, name, v) {
    return pass.set("@babel/plugin-react-jsx/".concat(name), v);
};
function hasProto(node) {
    return node.properties.some(function (value) {
        return core_1.types.isObjectProperty(value, { computed: false, shorthand: false }) &&
            (core_1.types.isIdentifier(value.key, { name: "__proto__" }) ||
                core_1.types.isStringLiteral(value.key, { value: "__proto__" }));
    });
}
function createPlugin(_a) {
    var name = _a.name, development = _a.development;
    return (0, helper_plugin_utils_1.declare)(function (_, options) {
        var PURE_ANNOTATION = options.pure, _a = options.throwIfNamespace, throwIfNamespace = _a === void 0 ? true : _a, filter = options.filter, _b = options.runtime, RUNTIME_DEFAULT = _b === void 0 ? process.env.BABEL_8_BREAKING
            ? "automatic"
            : development
                ? "automatic"
                : "classic" : _b, _c = options.importSource, IMPORT_SOURCE_DEFAULT = _c === void 0 ? DEFAULT.importSource : _c, _d = options.pragma, PRAGMA_DEFAULT = _d === void 0 ? DEFAULT.pragma : _d, _e = options.pragmaFrag, PRAGMA_FRAG_DEFAULT = _e === void 0 ? DEFAULT.pragmaFrag : _e;
        if (process.env.BABEL_8_BREAKING) {
            if ("useSpread" in options) {
                throw new Error('@babel/plugin-transform-react-jsx: Since Babel 8, an inline object with spread elements is always used, and the "useSpread" option is no longer available. Please remove it from your config.');
            }
            if ("useBuiltIns" in options) {
                var useBuiltInsFormatted = JSON.stringify(options.useBuiltIns);
                throw new Error("@babel/plugin-transform-react-jsx: Since \"useBuiltIns\" is removed in Babel 8, you can remove it from the config.\n- Babel 8 now transforms JSX spread to object spread. If you need to transpile object spread with\n`useBuiltIns: ".concat(useBuiltInsFormatted, "`, you can use the following config\n{\n  \"plugins\": [\n    \"@babel/plugin-transform-react-jsx\"\n    [\"@babel/plugin-transform-object-rest-spread\", { \"loose\": true, \"useBuiltIns\": ").concat(useBuiltInsFormatted, " }]\n  ]\n}"));
            }
            if (filter != null && RUNTIME_DEFAULT === "automatic") {
                throw new Error('@babel/plugin-transform-react-jsx: "filter" option can not be used with automatic runtime. If you are upgrading from Babel 7, please specify `runtime: "classic"`.');
            }
        }
        else {
            // eslint-disable-next-line no-var
            var _f = options.useSpread, useSpread = _f === void 0 ? false : _f, _g = options.useBuiltIns, useBuiltIns = _g === void 0 ? false : _g;
            if (RUNTIME_DEFAULT === "classic") {
                if (typeof useSpread !== "boolean") {
                    throw new Error("transform-react-jsx currently only accepts a boolean option for " +
                        "useSpread (defaults to false)");
                }
                if (typeof useBuiltIns !== "boolean") {
                    throw new Error("transform-react-jsx currently only accepts a boolean option for " +
                        "useBuiltIns (defaults to false)");
                }
                if (useSpread && useBuiltIns) {
                    throw new Error("transform-react-jsx currently only accepts useBuiltIns or useSpread " +
                        "but not both");
                }
            }
        }
        var injectMetaPropertiesVisitor = {
            JSXOpeningElement: function (path, state) {
                var attributes = [];
                if (isThisAllowed(path.scope)) {
                    attributes.push(core_1.types.jsxAttribute(core_1.types.jsxIdentifier("__self"), core_1.types.jsxExpressionContainer(core_1.types.thisExpression())));
                }
                attributes.push(core_1.types.jsxAttribute(core_1.types.jsxIdentifier("__source"), core_1.types.jsxExpressionContainer(makeSource(path, state))));
                path.pushContainer("attributes", attributes);
            }
        };
        return {
            name: name,
            inherits: plugin_syntax_jsx_1["default"],
            visitor: {
                JSXNamespacedName: function (path) {
                    if (throwIfNamespace) {
                        throw path.buildCodeFrameError("Namespace tags are not supported by default. React's JSX doesn't support namespace tags. You can set `throwIfNamespace: false` to bypass this warning.");
                    }
                },
                JSXSpreadChild: function (path) {
                    throw path.buildCodeFrameError("Spread children are not supported in React.");
                },
                Program: {
                    enter: function (path, state) {
                        var file = state.file;
                        var runtime = RUNTIME_DEFAULT;
                        var source = IMPORT_SOURCE_DEFAULT;
                        var pragma = PRAGMA_DEFAULT;
                        var pragmaFrag = PRAGMA_FRAG_DEFAULT;
                        var sourceSet = !!options.importSource;
                        var pragmaSet = !!options.pragma;
                        var pragmaFragSet = !!options.pragmaFrag;
                        if (file.ast.comments) {
                            for (var _i = 0, _a = file.ast.comments; _i < _a.length; _i++) {
                                var comment = _a[_i];
                                var sourceMatches = JSX_SOURCE_ANNOTATION_REGEX.exec(comment.value);
                                if (sourceMatches) {
                                    source = sourceMatches[1];
                                    sourceSet = true;
                                }
                                var runtimeMatches = JSX_RUNTIME_ANNOTATION_REGEX.exec(comment.value);
                                if (runtimeMatches) {
                                    runtime = runtimeMatches[1];
                                }
                                var jsxMatches = JSX_ANNOTATION_REGEX.exec(comment.value);
                                if (jsxMatches) {
                                    pragma = jsxMatches[1];
                                    pragmaSet = true;
                                }
                                var jsxFragMatches = JSX_FRAG_ANNOTATION_REGEX.exec(comment.value);
                                if (jsxFragMatches) {
                                    pragmaFrag = jsxFragMatches[1];
                                    pragmaFragSet = true;
                                }
                            }
                        }
                        set(state, "runtime", runtime);
                        if (runtime === "classic") {
                            if (sourceSet) {
                                throw path.buildCodeFrameError("importSource cannot be set when runtime is classic.");
                            }
                            var createElement_1 = toMemberExpression(pragma);
                            var fragment_1 = toMemberExpression(pragmaFrag);
                            set(state, "id/createElement", function () { return core_1.types.cloneNode(createElement_1); });
                            set(state, "id/fragment", function () { return core_1.types.cloneNode(fragment_1); });
                            set(state, "defaultPure", pragma === DEFAULT.pragma);
                        }
                        else if (runtime === "automatic") {
                            if (pragmaSet || pragmaFragSet) {
                                throw path.buildCodeFrameError("pragma and pragmaFrag cannot be set when runtime is automatic.");
                            }
                            var define = function (name, id) {
                                return set(state, name, createImportLazily(state, path, id, source));
                            };
                            define("id/jsx", development ? "jsxDEV" : "jsx");
                            define("id/jsxs", development ? "jsxDEV" : "jsxs");
                            define("id/createElement", "createElement");
                            define("id/fragment", "Fragment");
                            set(state, "defaultPure", source === DEFAULT.importSource);
                        }
                        else {
                            throw path.buildCodeFrameError("Runtime must be either \"classic\" or \"automatic\".");
                        }
                        if (development) {
                            path.traverse(injectMetaPropertiesVisitor, state);
                        }
                    }
                },
                JSXFragment: {
                    exit: function (path, file) {
                        var callExpr;
                        if (get(file, "runtime") === "classic") {
                            callExpr = buildCreateElementFragmentCall(path, file);
                        }
                        else {
                            callExpr = buildJSXFragmentCall(path, file);
                        }
                        path.replaceWith(core_1.types.inherits(callExpr, path.node));
                    }
                },
                JSXElement: {
                    exit: function (path, file) {
                        var callExpr;
                        if (get(file, "runtime") === "classic" ||
                            shouldUseCreateElement(path)) {
                            callExpr = buildCreateElementCall(path, file);
                        }
                        else {
                            callExpr = buildJSXElementCall(path, file);
                        }
                        path.replaceWith(core_1.types.inherits(callExpr, path.node));
                    }
                },
                JSXAttribute: function (path) {
                    if (core_1.types.isJSXElement(path.node.value)) {
                        path.node.value = core_1.types.jsxExpressionContainer(path.node.value);
                    }
                }
            }
        };
        // Returns whether the class has specified a superclass.
        function isDerivedClass(classPath) {
            return classPath.node.superClass !== null;
        }
        // Returns whether `this` is allowed at given scope.
        function isThisAllowed(scope) {
            // This specifically skips arrow functions as they do not rewrite `this`.
            do {
                var path = scope.path;
                if (path.isFunctionParent() && !path.isArrowFunctionExpression()) {
                    if (!path.isMethod()) {
                        // If the closest parent is a regular function, `this` will be rebound, therefore it is fine to use `this`.
                        return true;
                    }
                    // Current node is within a method, so we need to check if the method is a constructor.
                    if (path.node.kind !== "constructor") {
                        // We are not in a constructor, therefore it is always fine to use `this`.
                        return true;
                    }
                    // Now we are in a constructor. If it is a derived class, we do not reference `this`.
                    return !isDerivedClass(path.parentPath.parentPath);
                }
                if (path.isTSModuleBlock()) {
                    // If the closest parent is a TS Module block, `this` will not be allowed.
                    return false;
                }
            } while ((scope = scope.parent));
            // We are not in a method or function. It is fine to use `this`.
            return true;
        }
        function call(pass, name, args) {
            var node = core_1.types.callExpression(get(pass, "id/".concat(name))(), args);
            if (PURE_ANNOTATION !== null && PURE_ANNOTATION !== void 0 ? PURE_ANNOTATION : get(pass, "defaultPure"))
                (0, helper_annotate_as_pure_1["default"])(node);
            return node;
        }
        // We want to use React.createElement, even in the case of
        // jsx, for <div {...props} key={key} /> to distinguish it
        // from <div key={key} {...props} />. This is an intermediary
        // step while we deprecate key spread from props. Afterwards,
        // we will stop using createElement in the transform.
        function shouldUseCreateElement(path) {
            var openingPath = path.get("openingElement");
            var attributes = openingPath.node.attributes;
            var seenPropsSpread = false;
            for (var i = 0; i < attributes.length; i++) {
                var attr = attributes[i];
                if (seenPropsSpread &&
                    core_1.types.isJSXAttribute(attr) &&
                    attr.name.name === "key") {
                    return true;
                }
                else if (core_1.types.isJSXSpreadAttribute(attr)) {
                    seenPropsSpread = true;
                }
            }
            return false;
        }
        function convertJSXIdentifier(node, parent) {
            if (core_1.types.isJSXIdentifier(node)) {
                if (node.name === "this" && core_1.types.isReferenced(node, parent)) {
                    return core_1.types.thisExpression();
                }
                else if (core_1.types.isValidIdentifier(node.name, false)) {
                    node.type = "Identifier";
                    return node;
                }
                else {
                    return core_1.types.stringLiteral(node.name);
                }
            }
            else if (core_1.types.isJSXMemberExpression(node)) {
                return core_1.types.memberExpression(convertJSXIdentifier(node.object, node), convertJSXIdentifier(node.property, node));
            }
            else if (core_1.types.isJSXNamespacedName(node)) {
                /**
                 * If the flag "throwIfNamespace" is false
                 * print XMLNamespace like string literal
                 */
                return core_1.types.stringLiteral("".concat(node.namespace.name, ":").concat(node.name.name));
            }
            // todo: this branch should be unreachable
            return node;
        }
        function convertAttributeValue(node) {
            if (core_1.types.isJSXExpressionContainer(node)) {
                return node.expression;
            }
            else {
                return node;
            }
        }
        function accumulateAttribute(array, attribute) {
            var _a;
            if (core_1.types.isJSXSpreadAttribute(attribute.node)) {
                var arg = attribute.node.argument;
                // Collect properties into props array if spreading object expression
                if (core_1.types.isObjectExpression(arg) && !hasProto(arg)) {
                    array.push.apply(array, arg.properties);
                }
                else {
                    array.push(core_1.types.spreadElement(arg));
                }
                return array;
            }
            var value = convertAttributeValue(attribute.node.name.name !== "key"
                ? attribute.node.value || core_1.types.booleanLiteral(true)
                : attribute.node.value);
            if (attribute.node.name.name === "key" && value === null) {
                throw attribute.buildCodeFrameError('Please provide an explicit key value. Using "key" as a shorthand for "key={true}" is not allowed.');
            }
            if (core_1.types.isStringLiteral(value) &&
                !core_1.types.isJSXExpressionContainer(attribute.node.value)) {
                value.value = value.value.replace(/\n\s+/g, " ");
                // "raw" JSXText should not be used from a StringLiteral because it needs to be escaped.
                (_a = value.extra) === null || _a === void 0 ? true : delete _a.raw;
            }
            if (core_1.types.isJSXNamespacedName(attribute.node.name)) {
                attribute.node.name = core_1.types.stringLiteral(attribute.node.name.namespace.name +
                    ":" +
                    attribute.node.name.name.name);
            }
            else if (core_1.types.isValidIdentifier(attribute.node.name.name, false)) {
                attribute.node.name.type = "Identifier";
            }
            else {
                attribute.node.name = core_1.types.stringLiteral(attribute.node.name.name);
            }
            array.push(core_1.types.inherits(core_1.types.objectProperty(attribute.node.name, value), attribute.node));
            return array;
        }
        // Builds JSX into:
        // Production: React.jsx(type, arguments, key)
        // Development: React.jsxDEV(type, arguments, key, isStaticChildren, source, self)
        function buildJSXElementCall(path, file) {
            var _a;
            var openingPath = path.get("openingElement");
            var args = [getTag(openingPath)];
            var attribsArray = [];
            var extracted = Object.create(null);
            // for React.jsx, key, __source (dev), and __self (dev) is passed in as
            // a separate argument rather than in the args object. We go through the
            // props and filter out these three keywords so we can pass them in
            // as separate arguments later
            for (var _i = 0, _b = openingPath.get("attributes"); _i < _b.length; _i++) {
                var attr = _b[_i];
                if (attr.isJSXAttribute() && core_1.types.isJSXIdentifier(attr.node.name)) {
                    var name_1 = attr.node.name.name;
                    switch (name_1) {
                        case "__source":
                        case "__self":
                            if (extracted[name_1])
                                throw sourceSelfError(path, name_1);
                        /* falls through */
                        case "key": {
                            var keyValue = convertAttributeValue(attr.node.value);
                            if (keyValue === null) {
                                throw attr.buildCodeFrameError('Please provide an explicit key value. Using "key" as a shorthand for "key={true}" is not allowed.');
                            }
                            extracted[name_1] = keyValue;
                            break;
                        }
                        default:
                            attribsArray.push(attr);
                    }
                }
                else {
                    attribsArray.push(attr);
                }
            }
            var children = core_1.types.react.buildChildren(path.node);
            var attribs;
            if (attribsArray.length || children.length) {
                attribs = buildJSXOpeningElementAttributes(attribsArray);
            }
            else {
                // attributes should never be null
                attribs = core_1.types.objectExpression([]);
            }
            args.push(attribs);
            if ((children === null || children === void 0 ? void 0 : children.length) > 0) {
                children.forEach(function (child) { return args.push(child); });
            }
            if (development) {
                // isStaticChildren, __source, and __self are only used in development
                // automatically include __source and __self in this plugin
                // so we can eliminate the need for separate Babel plugins in Babel 8
                args.push((_a = extracted.key) !== null && _a !== void 0 ? _a : path.scope.buildUndefinedNode(), core_1.types.booleanLiteral(children.length > 1));
                if (extracted.__source) {
                    args.push(extracted.__source);
                    if (extracted.__self)
                        args.push(extracted.__self);
                }
                else if (extracted.__self) {
                    args.push(path.scope.buildUndefinedNode(), extracted.__self);
                }
            }
            else if (extracted.key !== undefined) {
                args.push(extracted.key);
            }
            return call(file, children.length > 1 ? "jsxs" : "jsx", args);
        }
        // Builds props for React.jsx.
        function buildJSXOpeningElementAttributes(attribs) {
            var props = attribs.reduce(accumulateAttribute, []);
            return core_1.types.objectExpression(props);
        }
        // Builds JSX Fragment <></> into
        // Production: React.jsx(type, arguments)
        // Development: React.jsxDEV(type, { children })
        function buildJSXFragmentCall(path, file) {
            var args = [get(file, "id/fragment")()];
            var children = core_1.types.react.buildChildren(path.node);
            args.push(core_1.types.objectExpression([]));
            if ((children === null || children === void 0 ? void 0 : children.length) > 0) {
                children.forEach(function (child) { return args.push(child); });
            }
            if (development) {
                args.push(path.scope.buildUndefinedNode(), core_1.types.booleanLiteral(children.length > 1));
            }
            return call(file, children.length > 1 ? "jsxs" : "jsx", args);
        }
        // Builds JSX Fragment <></> into
        // React.createElement(React.Fragment, null, ...children)
        function buildCreateElementFragmentCall(path, file) {
            if (filter && !filter(path.node, file))
                return;
            return call(file, "createElement", __spreadArray([
                get(file, "id/fragment")(),
                core_1.types.nullLiteral()
            ], core_1.types.react.buildChildren(path.node), true));
        }
        // Builds JSX into:
        // Production: React.createElement(type, arguments, children)
        // Development: React.createElement(type, arguments, children, source, self)
        function buildCreateElementCall(path, file) {
            var openingPath = path.get("openingElement");
            return call(file, "createElement", __spreadArray([
                getTag(openingPath),
                buildCreateElementOpeningElementAttributes(file, path, openingPath.get("attributes"))
            ], core_1.types.react.buildChildren(path.node), true));
        }
        function getTag(openingPath) {
            var tagExpr = convertJSXIdentifier(openingPath.node.name, openingPath.node);
            var tagName;
            if (core_1.types.isIdentifier(tagExpr)) {
                tagName = tagExpr.name;
            }
            else if (core_1.types.isStringLiteral(tagExpr)) {
                tagName = tagExpr.value;
            }
            if (core_1.types.react.isCompatTag(tagName)) {
                return core_1.types.stringLiteral(tagName);
            }
            else {
                return tagExpr;
            }
        }
        /**
         * The logic for this is quite terse. It's because we need to
         * support spread elements. We loop over all attributes,
         * breaking on spreads, we then push a new object containing
         * all prior attributes to an array for later processing.
         */
        function buildCreateElementOpeningElementAttributes(file, path, attribs) {
            var runtime = get(file, "runtime");
            if (!process.env.BABEL_8_BREAKING) {
                if (runtime !== "automatic") {
                    var objs_1 = [];
                    var props_1 = attribs.reduce(accumulateAttribute, []);
                    if (!useSpread) {
                        // Convert syntax to use multiple objects instead of spread
                        var start_1 = 0;
                        props_1.forEach(function (prop, i) {
                            if (core_1.types.isSpreadElement(prop)) {
                                if (i > start_1) {
                                    objs_1.push(core_1.types.objectExpression(props_1.slice(start_1, i)));
                                }
                                objs_1.push(prop.argument);
                                start_1 = i + 1;
                            }
                        });
                        if (props_1.length > start_1) {
                            objs_1.push(core_1.types.objectExpression(props_1.slice(start_1)));
                        }
                    }
                    else if (props_1.length) {
                        objs_1.push(core_1.types.objectExpression(props_1));
                    }
                    if (!objs_1.length) {
                        return core_1.types.nullLiteral();
                    }
                    if (objs_1.length === 1) {
                        if (!(core_1.types.isSpreadElement(props_1[0]) &&
                            // If an object expression is spread element's argument
                            // it is very likely to contain __proto__ and we should stop
                            // optimizing spread element
                            core_1.types.isObjectExpression(props_1[0].argument))) {
                            return objs_1[0];
                        }
                    }
                    // looks like we have multiple objects
                    if (!core_1.types.isObjectExpression(objs_1[0])) {
                        objs_1.unshift(core_1.types.objectExpression([]));
                    }
                    var helper = useBuiltIns
                        ? core_1.types.memberExpression(core_1.types.identifier("Object"), core_1.types.identifier("assign"))
                        : file.addHelper("extends");
                    // spread it
                    return core_1.types.callExpression(helper, objs_1);
                }
            }
            var props = [];
            var found = Object.create(null);
            for (var _i = 0, attribs_1 = attribs; _i < attribs_1.length; _i++) {
                var attr = attribs_1[_i];
                var node = attr.node;
                var name_2 = core_1.types.isJSXAttribute(node) &&
                    core_1.types.isJSXIdentifier(node.name) &&
                    node.name.name;
                if (runtime === "automatic" &&
                    (name_2 === "__source" || name_2 === "__self")) {
                    if (found[name_2])
                        throw sourceSelfError(path, name_2);
                    found[name_2] = true;
                }
                accumulateAttribute(props, attr);
            }
            return props.length === 1 &&
                core_1.types.isSpreadElement(props[0]) &&
                // @ts-expect-error
                // If an object expression is spread element's argument
                // it is very likely to contain __proto__ and we should stop
                // optimizing spread element
                !core_1.types.isObjectExpression(props[0].argument)
                // @ts-expect-error
                ? props[0].argument
                : props.length > 0
                    ? core_1.types.objectExpression(props)
                    : core_1.types.nullLiteral();
        }
    });
    function getSource(source, importName) {
        switch (importName) {
            case "Fragment":
                return "".concat(source, "/").concat(development ? "jsx-dev-runtime" : "jsx-runtime");
            case "jsxDEV":
                return "".concat(source, "/jsx-dev-runtime");
            case "jsx":
            case "jsxs":
                return "".concat(source, "/jsx-runtime");
            case "createElement":
                return source;
        }
    }
    function createImportLazily(pass, path, importName, source) {
        return function () {
            var actualSource = getSource(source, importName);
            if ((0, helper_module_imports_1.isModule)(path)) {
                var reference = get(pass, "imports/".concat(importName));
                if (reference)
                    return core_1.types.cloneNode(reference);
                reference = (0, helper_module_imports_1.addNamed)(path, importName, actualSource, {
                    importedInterop: "uncompiled",
                    importPosition: "after"
                });
                set(pass, "imports/".concat(importName), reference);
                return reference;
            }
            else {
                var reference = get(pass, "requires/".concat(actualSource));
                if (reference) {
                    reference = core_1.types.cloneNode(reference);
                }
                else {
                    reference = (0, helper_module_imports_1.addNamespace)(path, actualSource, {
                        importedInterop: "uncompiled"
                    });
                    set(pass, "requires/".concat(actualSource), reference);
                }
                return core_1.types.memberExpression(reference, core_1.types.identifier(importName));
            }
        };
    }
}
exports["default"] = createPlugin;
function toMemberExpression(id) {
    return (id
        .split(".")
        .map(function (name) { return core_1.types.identifier(name); })
        // where the type of initial value differs from callback return type
        .reduce(function (object, property) { return core_1.types.memberExpression(object, property); }));
}
function makeSource(path, state) {
    var location = path.node.loc;
    if (!location) {
        // the element was generated and doesn't have location information
        return path.scope.buildUndefinedNode();
    }
    if (!state.fileNameIdentifier) {
        var _a = state.filename, filename = _a === void 0 ? "" : _a;
        var fileNameIdentifier = path.scope.generateUidIdentifier("_jsxFileName");
        path.scope.getProgramParent().push({
            id: fileNameIdentifier,
            init: core_1.types.stringLiteral(filename)
        });
        state.fileNameIdentifier = fileNameIdentifier;
    }
    return makeTrace(core_1.types.cloneNode(state.fileNameIdentifier), location.start.line, location.start.column);
}
function makeTrace(fileNameIdentifier, lineNumber, column0Based) {
    var fileLineLiteral = lineNumber != null ? core_1.types.numericLiteral(lineNumber) : core_1.types.nullLiteral();
    var fileColumnLiteral = column0Based != null ? core_1.types.numericLiteral(column0Based + 1) : core_1.types.nullLiteral();
    return core_1.template.expression.ast(templateObject_1 || (templateObject_1 = __makeTemplateObject(["{\n    fileName: ", ",\n    lineNumber: ", ",\n    columnNumber: ", ",\n  }"], ["{\n    fileName: ", ",\n    lineNumber: ", ",\n    columnNumber: ", ",\n  }"])), fileNameIdentifier, fileLineLiteral, fileColumnLiteral);
}
function sourceSelfError(path, name) {
    var pluginName = "transform-react-jsx-".concat(name.slice(2));
    return path.buildCodeFrameError("Duplicate ".concat(name, " prop found. You are most likely using the deprecated ").concat(pluginName, " Babel plugin. Both __source and __self are automatically set when using the automatic runtime. Please remove transform-react-jsx-source and transform-react-jsx-self from your Babel config."));
}
var templateObject_1;
//# sourceMappingURL=create-plugin.js.map